MKULZMA(8)

NAME
mkulzma - compress disk image for use with geom_uncompress(4) class

SYNOPSIS
mkulzma [-v] [-o outfile] [-s cluster_size] infile

DESCRIPTION
The mkulzma utility compresses a disk image file so that the geom_uncompress(4) class will be able to decompress the resulting image at run-time. This allows for a significant reduction of size of disk image at the expense of some CPU time required to decompress the data each time it is read. The mkulzma utility works in two phases:

1.  An infile image is split into clusters; each cluster is compressed using liblzma.

2.  The resulting set of compressed clusters along with headers that allow locating each individual cluster is written to the output file.

The options are:

-o outfile
    Name of the output file outfile. The default is to use the input name with the suffix .ulzma.

-s cluster_size
    Split the image into clusters of cluster_size bytes, 16384 bytes by default. The cluster_size should be a multiple of 512 bytes.

-v  Display verbose messages.

NOTES
The compression ratio largely depends on the cluster size used. For large cluster sizes (16K and higher), typical compression ratios are only 1-2% less than those achieved with lzma(1). However, it should be kept in mind that larger cluster sizes lead to higher overhead in the geom_uncompress(4) class, as the class has to decompress the whole cluster even if only a few bytes from that cluster have to be read.

The mkulzma utility inserts a short shell script at the beginning of the generated image, which makes it possible to “run” the image just like any other shell script. The script tries to load the geom_uncompress(4) class if it is not loaded, configure the image as an md(4) disk device using mdconfig(8), and automatically mount it using mount_cd9660(8) on the mount point provided as the first argument to the script.

EXIT STATUS

SEE ALSO
lzma(1), geom(4), geom_uncompress(4), md(4), mdconfig(8), mount_cd9660(8)

AUTHORS
Maxim Sobolev <sobomax@FreeBSD.org> Aleksandr Rybalko <ray@ddteam.net>